# nshmp-lib

***nshmp-lib*** is a USGS developed Java library that supports probabilistic seismic hazard (PSHA)
and related analyses. This project includes all the code required to load, process and query USGS
National Seismic Hazard Models (NSHMs). *nshmp-lib* is used by command line applications and web
services found in the [*nshmp-haz*](https://code.usgs.gov/ghsc/nshmp/nshmp-haz) project. See that
project for running PSHA calculations.

The project uses [Gradle](https://gradle.org/) for building and testing. To run unit tests and
create a JAR file for use in other projects, run `./gradlew build` from the root of the repository.
(or `./gradlew.bat build` if using Windows).

See also:

* [*nshmp-haz*](https://code.usgs.gov/ghsc/nshmp/nshmp-haz) and related
  [documentation](https://code.usgs.gov/ghsc/nshmp/nshmp-haz/-/blob/main/docs/README.md)
* Project [Javadocs](https://earthquake.usgs.gov/nshmp/docs/nshmp-lib/)
