package gov.usgs.earthquake.nshmp.tree;

import static gov.usgs.earthquake.nshmp.data.DoubleData.checkWeight;
import static gov.usgs.earthquake.nshmp.tree.RegularBranch.checkId;

/**
 * Branch with identical id and value string.
 *
 * @author U.S. Geological Survey
 */
class StringValueBranch implements Branch<String> {

  private final String id;
  private final double weight;

  StringValueBranch(String id, double weight) {
    this.id = checkId(id);
    this.weight = checkWeight(weight);
  }

  @Override
  public String id() {
    return id;
  }

  @Override
  public String value() {
    return id;
  }

  @Override
  public double weight() {
    return weight;
  }

  @Override
  public String toString() {
    return RegularBranch.toString(id, weight);
  }
}
