package gov.usgs.earthquake.nshmp.gmm;

import static gov.usgs.earthquake.nshmp.gmm.Gmm.AG_20_ALASKA_ADJ_SLAB;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.AG_20_ALASKA_SLAB;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.AG_20_CASCADIA_ADJ_SLAB;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.AG_20_CASCADIA_ADJ_SLAB_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.AG_20_CASCADIA_SLAB;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.AG_20_CASCADIA_SLAB_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.AG_20_GLOBAL_SLAB;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.KBCG_20_ALASKA_SLAB;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.KBCG_20_CASCADIA_SLAB;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.KBCG_20_CASCADIA_SLAB_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.KBCG_20_GLOBAL_SLAB;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.PSHAB_20_ALASKA_SLAB;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.PSHAB_20_CASCADIA_SLAB;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.PSHAB_20_CASCADIA_SLAB_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.PSHAB_20_GLOBAL_SLAB;

import java.io.IOException;
import java.util.EnumSet;
import java.util.Set;
import java.util.stream.Stream;

import org.junit.jupiter.api.extension.ExtensionContext;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.Arguments;
import org.junit.jupiter.params.provider.ArgumentsProvider;
import org.junit.jupiter.params.provider.ArgumentsSource;

public class NgaSubSlab implements ArgumentsProvider {

  private static String GMM_INPUTS = "/gmm/NGA_SUB_slab_inputs.csv";
  private static String GMM_RESULTS = "/gmm/NGA_SUB_slab_results.csv";

  @ParameterizedTest(name = "({index}) {0} {2} {1}")
  @ArgumentsSource(NgaSubSlab.class)
  void test(int index, Gmm gmm, Imt imt, double exMedian, double exSigma, String inputs) {
    GmmTest.test(index, gmm, imt, exMedian, exSigma, inputs);
  }

  @Override
  public Stream<? extends Arguments> provideArguments(ExtensionContext context) throws Exception {
    return GmmTest.loadResults(GMM_RESULTS, GMM_INPUTS);
  }

  /* Result generation sets */
  private static Set<Gmm> gmms = EnumSet.of(
      AG_20_GLOBAL_SLAB,
      AG_20_CASCADIA_SLAB,
      AG_20_CASCADIA_SLAB_BASIN,
      AG_20_CASCADIA_ADJ_SLAB,
      AG_20_CASCADIA_ADJ_SLAB_BASIN,
      AG_20_ALASKA_SLAB,
      AG_20_ALASKA_ADJ_SLAB,
      KBCG_20_GLOBAL_SLAB,
      KBCG_20_CASCADIA_SLAB,
      KBCG_20_CASCADIA_SLAB_BASIN,
      KBCG_20_ALASKA_SLAB,
      PSHAB_20_GLOBAL_SLAB,
      PSHAB_20_CASCADIA_SLAB,
      PSHAB_20_CASCADIA_SLAB_BASIN,
      PSHAB_20_ALASKA_SLAB);

  public static void main(String[] args) throws IOException {
    GmmTest.generateResults(gmms, Imt.mprsImts(), GMM_INPUTS, GMM_RESULTS);
  }

}
